﻿using System;
using System.Windows;
using System.Windows.Media;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;

namespace SimpleAudioStreaming
{
    public partial class MainPage : PhoneApplicationPage
    {
        public MainPage()
        {
            InitializeComponent();

            // Get app bar buttons
            playButton = this.ApplicationBar.Buttons[0] as ApplicationBarIconButton;
            pauseButton = this.ApplicationBar.Buttons[1] as ApplicationBarIconButton;
        }

        protected override void OnNavigatedTo(NavigationEventArgs args)
        {
            // Set MediaStreamSource derivative to MediaElement
            mediaElement.SetSource(new Sine440AudioStreamSource(44100));
            base.OnNavigatedTo(args);
        }

        void OnMediaElementCurrentStateChanged(object sender, RoutedEventArgs args)
        {
            statusTextBlock.Text = mediaElement.CurrentState.ToString();
            playButton.IsEnabled = mediaElement.CurrentState != MediaElementState.Playing;
            pauseButton.IsEnabled = mediaElement.CurrentState == MediaElementState.Playing;
        }

        void OnPlayButtonClick(object sender, EventArgs args)
        {
            mediaElement.Play();
            playButton.IsEnabled = false;
        }

        void OnPauseButtonClick(object sender, EventArgs args)
        {
            mediaElement.Pause();
            pauseButton.IsEnabled = false;
        }
    }
}