﻿using System;
using Microsoft.Phone.BackgroundAudio;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;

namespace PentatonicRambler
{
    public partial class MainPage : PhoneApplicationPage
    {
        public MainPage()
        {
            InitializeComponent();
            playButton = this.ApplicationBar.Buttons[0] as ApplicationBarIconButton;
            pauseButton = this.ApplicationBar.Buttons[1] as ApplicationBarIconButton;

            BackgroundAudioPlayer.Instance.PlayStateChanged += OnBackgroundAudioPlayerPlayStateChanged;

            // Initialize by calling event handler manually
            OnBackgroundAudioPlayerPlayStateChanged(null, EventArgs.Empty);
        }

        void OnBackgroundAudioPlayerPlayStateChanged(object sender, EventArgs args)
        {
            PlayState playState = BackgroundAudioPlayer.Instance.PlayerState; ;
            statusTextBlock.Text = "Status: " + playState;

            playButton.IsEnabled = playState == PlayState.Paused ||
                                   playState == PlayState.Stopped ||
                                   playState == PlayState.Unknown;

            pauseButton.IsEnabled = playState == PlayState.Playing;
        }

        private void OnPlayButtonClick(object sender, EventArgs args)
        {
            if (BackgroundAudioPlayer.Instance.Track == null)
            {
                BackgroundAudioPlayer.Instance.Track =
                    new AudioTrack(null, "Pentatonic Rambler", null, null, null, null, EnabledPlayerControls.Pause);
                BackgroundAudioPlayer.Instance.Volume = 1;
            }
            else
            {
                BackgroundAudioPlayer.Instance.Play();
            }
            playButton.IsEnabled = false;
        }

        private void OnPauseButtonClick(object sender, EventArgs args)
        {
            BackgroundAudioPlayer.Instance.Pause();
            pauseButton.IsEnabled = false;
        }
    }
}