﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace Petzold.MusicSynthesis.Controls
{
    public class FixedLengthCollection<T> : ObservableCollection<T> where T: new()
    {
        public FixedLengthCollection(int length)
        {
            for (int i = 0; i < length; i++)
                this.Add(new T());
        }

        protected override void OnPropertyChanged(PropertyChangedEventArgs args)
        {
            if (args.PropertyName == "Length")
                throw new InvalidOperationException("FixedLengthCollection is of fixed length " + this.Count);

            base.OnPropertyChanged(args);
        }
    }
}
