﻿using System.Windows;
using System.Windows.Controls;

namespace Petzold.MusicSynthesis.Controls
{
    public partial class WaveformerNode : UserControl
    {
        public static readonly DependencyProperty PointProperty =
            DependencyProperty.Register("Point",
                typeof(Point),
                typeof(WaveformerNode),
                new PropertyMetadata(new Point(0, 0), OnPointPropertyChanged));

        public WaveformerNode()
        {
            InitializeComponent();
        }

        public Point Point
        {
            set { SetValue(PointProperty, value); }
            get { return (Point)GetValue(PointProperty); }
        }

        static void OnPointPropertyChanged(DependencyObject obj, DependencyPropertyChangedEventArgs args)
        {
            (obj as WaveformerNode).OnPointPropertyChanged(args);
        }

        void OnPointPropertyChanged(DependencyPropertyChangedEventArgs args)
        {
            Point pt = (Point)args.NewValue;
            Canvas.SetLeft(this, pt.X - this.ActualWidth / 2);
            Canvas.SetTop(this, pt.Y - this.ActualHeight / 2);
        }
    }
}
