﻿using System;
using System.Windows;

namespace Petzold.MusicSynthesis
{
    public class AlmostSquareWave : VariableWaveformOscillator
    {
        const double INCREMENT = Math.PI / 16;

        public AlmostSquareWave(int sampleRate)
            : base(sampleRate)
        {
            for (double angle = INCREMENT; angle < 2 * Math.PI; angle += INCREMENT)
            {
                if (angle < Math.PI)
                    this.Points.Add(new Point(angle, 1));

                else if (angle == Math.PI)
                    this.Points.Add(new Point(angle, 0));

                else
                    this.Points.Add(new Point(angle, -1));
            }
        }
    }
}
