﻿using System.Collections.Generic;

namespace Petzold.MusicSynthesis
{
    public class Mixer : IStereoSampleProvider
    {
        public Mixer()
        {
            this.Inputs = new List<MixerInput>();
            this.Volume = 1;
        }

        public IList<MixerInput> Inputs { protected set; get; }

        public double Volume { set; get; }

        public AudioSample GetNextSample()
        {
            int left = 0;
            int right = 0;

            foreach (MixerInput mixerInput in this.Inputs)
            {
                AudioSample audioSample = mixerInput.GetNextSample();
                left += audioSample.Left;
                right += audioSample.Right;
            }

            return new AudioSample
            {
                Left = (short)(this.Volume * left / this.Inputs.Count),
                Right = (short)(this.Volume * right / this.Inputs.Count)
            };
        }
    }
}
