﻿using System.Collections.Generic;

namespace Petzold.MusicSynthesis
{
    public class Sequencer : SteadyNoteDurationPlayer
    {
        int noteIndex = -1;

        public Sequencer(int sampleRate) 
            : base(sampleRate)
        {
            this.Pitches = new List<Pitch>();
        }

        public IList<Pitch> Pitches { protected set; get; }

        protected override Pitch GetNextPitch()
        {
            if (this.Pitches.Count == 0)
                return new Pitch();

            noteIndex += 1;

            if (noteIndex >= this.Pitches.Count)
                noteIndex = 0;

            return this.Pitches[noteIndex];
        }
    }
}
